apeman-api-path
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-api-labo/apeman-api-path
[bd_travis_url]: http://travis-ci.org/apeman-api-labo/apeman-api-path
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-api-labo/apeman-api-path.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-api-labo/apeman-api-path
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-api-labo/apeman-api-path.svg?token=
[bd_license_url]: https://github.com/apeman-api-labo/apeman-api-path/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-api-labo/apeman-api-path
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-api-labo/apeman-api-path.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-api-labo/apeman-api-path.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-api-labo/apeman-api-path
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-api-labo/apeman-api-path.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-api-path
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-api-path.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

File path API for apeman

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-api-path --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

Define a module in Apemanfile and run the server.

```javascript
/** Example of Apemanfile.js */

'use strict'

const co = require('co')

let { NODE_ENV } = process.env

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  $api: {
    // Define APIs
    'path': require('apeman-api-path')({
      logging: NODE_ENV === 'development',
      root: {
        
      }
    })
  }
}

```

Then, call the module from client script

```javascript
#!/usr/bin/env node

/**
 * Example client
 */
'use strict'

const co = require('co')
const apemanApiClient = require('apeman-api-client')

co(function * () {
  // Setup an client
  let api = yield apemanApiClient('/api')

  // Connect to a module
  let path = yield api.connect('path')
  {
    let resolved = yield path.resolve('foo/bar', '../baz')
    console.log(resolved) // => foo/bar/baz
  }
  /* ... */
})


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Methods.md.hbs" Start -->

<a name="section-doc-guides-03-methods-md"></a>

Methods
---------

The following methods are provided by the API.

+ [.ping(pong)](#method-ping)
+ [.basename(filename)](#method-basename)
+ [.dirname(filename)](#method-dirname)
+ [.relative(from, to)](#method-relative)
+ [.resolve(filename)](#method-resolve)

<a name="method-ping"></a>
### .ping(pong)

Test the reachability of the api

| Param | Type | Description |
| ----- | ---- | ----------- |
| pong  | <code>string</code> | Pong message to return |

<a name="method-basename"></a>
### .basename(filename)

Get base name of file path.

| Param | Type | Description |
| ----- | ---- | ----------- |
| filename  | <code>string</code> | Filename |

<a name="method-dirname"></a>
### .dirname(filename)

Get directory name of file path.

| Param | Type | Description |
| ----- | ---- | ----------- |
| filename  | <code>string</code> | Filename |

<a name="method-relative"></a>
### .relative(from, to)

Get relative path.

| Param | Type | Description |
| ----- | ---- | ----------- |
| from  | <code>string</code> | Filename relative from |
| to  | <code>string</code> | Filename relative to |

<a name="method-resolve"></a>
### .resolve(filename)

Resolve a file path.

| Param | Type | Description |
| ----- | ---- | ----------- |
| filename  | <code>string</code> | File path name to resolve |



<!-- Section from "doc/guides/03.Methods.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-api-labo/apeman-api-path/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
