/**
 * Describe an apeman-api-path
 * @function describe
 * @returns {Object}
 */
'use strict'

/** @lends describe */
function describe () {
  return {
    ping: {
      desc: 'Test the reachability of the api',
      params: [
        { name: 'pong', type: 'string', default: 'pong', desc: 'Pong message to return' }
      ],
      returns: {
        type: 'string', desc: 'Pong message'
      }
    },
    basename: {
      desc: 'Get base name of file path.',
      params: [
        { name: 'filename', type: 'string', desc: 'Filename' }
      ],
      returns: {
        types: 'string', desc: 'Base name'
      }
    },
    dirname: {
      desc: 'Get directory name of file path.',
      params: [
        { name: 'filename', type: 'string', desc: 'Filename' }
      ],
      returns: {
        types: 'string', desc: 'Directory name'
      }
    },
    relative: {
      desc: 'Get relative path.',
      params: [
        { name: 'from', type: 'string', desc: 'Filename relative from' },
        { name: 'to', type: 'string', desc: 'Filename relative to' }
      ],
      returns: {
        types: 'string', desc: 'Relative file name'
      }
    },
    resolve: {
      desc: 'Resolve a file path.',
      params: [
        { name: 'filename', type: 'string', desc: 'File path name to resolve' }
      ],
      returns: {
        type: 'string', desc: 'Resolved file path'
      }
    }
  }
}

module.exports = describe
